/*
 * shohaku
 * Copyright (C) 2005  tomoya nagatani
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package shohaku.composer.node.collection;

import java.util.Collections;

import shohaku.composer.node.AbstractValueNode;

/**
 * <code>name</code> 属性またはタグ名をキーとして内部要素の文字列表現を値とする要素を一つ持つマップを生成するノードを提供します。
 */
public class NamedTextSingletonMapNode extends AbstractValueNode {

    /**
     * 値を生成して返却します。
     * 
     * @return 生成された値
     */
    protected Object generateValue() {
        String key = getAttribute("name", getNodeContext().getNodeName());
        String value = getAttribute("value");
        if (value == null) {
            value = getText();
        }
        return Collections.singletonMap(key, value);
    }

}